import java.util.*;

// Verwaltet die Artikel
class Artikeln
    {
    private Daten[] a = new Daten[30];
    private int anz;
    
    // Konstruktor
    Artikeln ()
	{
	anz = 0;
	}


    // Hier werden die Artikeldaten abgelegt
    private class Daten
        {
        int nummer = 0;
        String name = null;
        double preis = 0;
    
    
        // Konstruktor fr neues Element
        Daten(int nr, String na, double p)
	    {
		nummer= nr;
	    name = na;
	    preis = p;
	    }
        }


    // Konstruktor: Liet die Artikel ein
    void DatenLesen (String path, String filename, MagList l) throws MyException
	{
	String s = null;
	ReadFile file;

	// Versucht File zu ffnen. Wenn nicht mglich, Abbruch
	try {
	    file = new ReadFile (path, filename);
	    }
	catch (MyException e)
	    {
	    throw new MyException (e.getMessage ());
	    }
    
	while ((s = file.readLine()) != null)
	    {
    	    // Wenn zu viele Artikel: Abbruch
	    if (anz >= 30)
		throw new MyException ("Zu viel Artikel im File - Es wurden nur die ersten 30 bercksichtigt.");
		
	    try 
		{
		// Wandelt einen String ins Artikelformat um
		StringtoArtikel (s);
		}
	    catch (MyException e)
		{
		l.add ("Fehler: " + e.getMessage(), false);
		}
	    }
	file.close ();
	if (anz == 0)
	    throw new MyException ("Es wurden keine Daten eingelesen - Programmabbruch");
	}


    // Versucht den bergebenen String im Array "Artikel" abzulegen	
    private void StringtoArtikel (String s) throws MyException
	{
	int nummer = 0;
	String name = null;
	double preis = 0;
	
	// Initialisiert Stringteiler und definiert die Trennzeichen
	StringTokenizer T = new StringTokenizer (s, ",");

	try {
	    // berprft, ob die Parameteranzahl korrekt ist
	    if ((T.countTokens () != 3) || (s.charAt (s.length () - 1) == ','))
		throw new MyException ("Falsche Syntax: " + s + " - Datensatz ignoriert.");

	    // Liet die Artikelnummer, wenn nicht dreistellig Abbruch
	    name = T.nextToken ();
	    if (name.length() !=3)
		throw new MyException ("Ungltige Artikelnummer im angegebenen File.");
	    nummer = Integer.parseInt (name);

	    // Liet Artikelnamen, berprft, ob der Artikelname zulssig ist, und bricht bei Fehler ab
	    name = T.nextToken ();
	    if (name.length() > 20)
		throw new MyException ("Artikelbezeichnung zu lang (max. 20 Zeichen)");
    
	    // Liet den Preis
	    preis = Double.valueOf(T.nextToken()).doubleValue();
	    } 
	catch (NumberFormatException e)
	    {
	    throw new MyException (e.getMessage());
	    }
	    
	// Wenn kein Fehler bei der Umwandlung aufgetreten ist, Datensatz speichern
	a[anz++] = new Daten (nummer,name,preis);
	}
	
	
    // Gibt die Liste aller vorhanden Artikel aus
    void printall (MagList l)
	{
	l.add ("Liste der vorhandenen Artikel:", true);
	for (int i = 0; i < anz; i++)
	    l.add (a[i].nummer + ", " + a[i].name + ", " + a[i].preis, false);
	l.add ("", false);
	}
    
    // Sucht in Artikeldaten nach bergebener Artikelnummer und gibt sie bei Erfolg zurck
    int find (int art)
	{
	for (int i = 0; i < anz; i++)
	    if (art == a[i].nummer)
		return (i);
	return -1;
	}
	
    // Gibt die Artikelnummer des gewnschten Artikel zurck
    int nummer (int j)
	{
	return a[j].nummer;
	}


    // Gibt den Artikelnamen des gewnschten Artikel zurck
    String name (int j)
	{
	return a[j].name;
	}

    
    // Gibt die Artikelnummer des gewnschten Artikel zurck
    double preis (int j)
	{
	return a[j].preis;
	}
	
    // liefert die Anzahl der Artikel
    int length ()
	{return anz;}
    }