import java.util.*;
import java.io.File;
import java.awt.*;
import java.awt.event.*;


class Beispiel1 extends Frame {
    final static String PFAD = "/mnt/import/java/tests/";
    final static String FILENAME = "artikel.txt";
    final static int STARTWIDTH = 300, STARTHEIGHT = 400;
    private static Font textfont, headerfont;
    private int textheight, headerheight, textwidht, headerwidht, enderg, maxwidth;
    private int rechmax [] = new int [6];
    private int artmax [] = new int [3];
    private static MagList ausg;
    
    /**
     * Konstruktor.
     * Hier wird der Frame initialisiert. Es wird ein Scrollpane und ein Canvas erzeugt.
     * Der Canvas wird dann in den Scrollpane gelegt. Bevor der Canvas aber erzeugt wird, werden
     * seine Abmessungen mit Hilfe von FontMetrics berechnet.
     */
    public Beispiel1 ()
	{
	// Auslesen der FontMetrics-Informationen
	headerheight = getFontMetrics (headerfont).getHeight();
	textheight = getFontMetrics (textfont).getHeight();
	textwidht = getFontMetrics (textfont).getMaxAdvance ();
	String s = null;

	// Berechnung der Canvasgrsse + Infosuche fr Formatierung
	maxwidth = 0;
	int n = 0, maxheight = 0;

	for (ausg.reset (); !ausg.eol (); ausg.gotoNext ())
	    // Wenn berschrift: Breitenberprfung, und Lngenberechnung
	    if (ausg.getStyle ())
		{
		maxheight += headerheight + 3 * textheight;
		if ((n = getFontMetrics (headerfont).stringWidth (ausg.getData ())) > maxwidth - 100)
		    maxwidth = n + 100;
		}
	    // Wenn Text: Breitenberprfung, und Lngenberechnung
	    else
		{
		maxheight += 1.3 * textheight;
		if ((n = getFontMetrics (textfont).stringWidth (ausg.getData ())) > maxwidth - 100)
		    maxwidth = n + 100;
		s = ausg.getData ();
		StringTokenizer T = new StringTokenizer (s,"\t");
		switch (T.countTokens ())
		    {
		    case 6: for (int i = 0; i < 6; i++)
				if ((n = getFontMetrics (textfont).stringWidth (T.nextToken())) > (rechmax[i] - 20))
				    rechmax[i] = n + 20;
			    break;
		    default: break;
		    }
		}
	enderg = rechmax [0] + rechmax [1] + rechmax [2] + rechmax [3] + rechmax [4];

	// Layout setzten, Canvas und ScrollPane initalisieren
	setLayout (new BorderLayout());
	  OutputCanvas output = new OutputCanvas (maxwidth + 40, maxheight + textheight);
	  ScrollPane scrollpane = new ScrollPane ();
	  scrollpane.add (output);
	  add (scrollpane);
	  scrollpane.doLayout ();

	  // Setzt Scrollbareinheiten
	  scrollpane.getHAdjustable().setUnitIncrement (textwidht);
	  scrollpane.getVAdjustable().setUnitIncrement (textheight);
	
	addWindowListener (new Fensterschliesser()); 
	}
    
    /**
     * Methode Fensterschliesser.
     * Implementier windowClosing Event in Frame.
     */
    class Fensterschliesser extends WindowAdapter
	{
	public void windowClosing (WindowEvent e)
	    {System.exit (0);}
	}
	
    /**
     * Klasse OutputCanvas.
     * Zeichenebene zur Ausgabe der Daten.
     */
    private class OutputCanvas extends Canvas
	{
	/**
	 * Konstruktor.
	 * Die Abmessungen werden initialisiert.
	 */
	OutputCanvas (int w, int h)
	    {
	    if (w < STARTWIDTH)
		w = STARTWIDTH;
	    if (h < STARTHEIGHT)
		h = STARTHEIGHT;
	    setSize (w, h);
	    }
	
	/**
	 * Methode paint
	 */
	public void paint (Graphics g)
	    {
	    g.setFont (textfont);	    
	    int i= 0, y;
	    String s = null;
	    
	    for (ausg.reset (); !ausg.eol (); ausg.gotoNext ())
		{
		if (ausg.getStyle())
		    {
		    g.setFont (headerfont);
		    i += 3 * textheight;
		    g.drawString (ausg.getData(), 30, i);
		    g.setFont (textfont);
		    i += headerheight;
		    }
		else
		    {
		    y = 30;
		    i += 1.3 * textheight;
		    s = ausg.getData ();
		    StringTokenizer T = new StringTokenizer (s, "\t");
		    switch (T.countTokens ())
			{
			case 6: for (int j = 0; j < 6; j++)
				    {
				    g.drawString (T.nextToken(), y, i);
				    y += rechmax [j];
				    }
				break;
			case 5: g.drawString (T.nextToken (), y, i);
				y += enderg; T.nextToken(); T.nextToken(); T.nextToken();
				g.drawString (T.nextToken (), y, i);
				break;
			case 3: for (int j = 0; j < 3; j++)
				    {
				    g.drawString (T.nextToken(), y, i);
				    y += rechmax [j];
				    }
				break;
			default: 
			    if (ausg.getData () != "=") g.drawString (ausg.getData (), 30, i);
			    else g.drawLine (y, i, y + maxwidth, i);
			break;
			}
		    }
		}
	    }
	}
	

    
    // Hauptprogramm
    public static void main(String argv[]) 
	{
	ausg = new MagList ();

	getParameters (argv);

	// Initialisierung der Varible a, dabei wird die Liste der Artikel eingelesen
        Artikeln a = new Artikeln ();

	// Einlesen der Artikel
	try {a.DatenLesen (PFAD, FILENAME, ausg);}
	catch (MyException e) {ausg.add (e.getMessage(), false);}

	if (a.length () > 0)
	    {
	    // Ausgabe der vorhanden Artikel in Zwischenbuffer
	    a.printall (ausg);

	    // Initialisiert die Rechnungsklasse
	    Rechnung r = new Rechnung ();

	    // Sucht alle Rechnungsfiles im angegebenen Pfad
	    String f[] = getRechnungsFilenames (PFAD);
	
	    // Falls keine Rechnungsfiles gefunden wurden
	    if (f.length == 0)
		ausg.add ("Im Angegebenen Verzeichnis wurden keine Rechnungsfiles gefunden.", false);
	
	    // Einlesen der Rechnungen aus dem File & deren Ausgabe
	    for (int i = 0; i < f.length; i++)
		{
		ausg.add (f[i], true);

		try {
		    r.load (PFAD, f[i], ausg);
		    }
		catch (MyException e)
		    {
		    ausg.add (e.getMessage(), false);
		    }
		Berechnung b = new Berechnung (a, r, ausg);
		r.destroy ();
		}
	    }

	// Startet Ausgabe in Frame
	Frame frame = new Beispiel1 ();
	frame.setSize (STARTWIDTH, STARTHEIGHT);
	frame.setTitle ("Beispiel 1: Rechnungserstellung");
	frame.setVisible (true);
	}
	
    // Liet Directory in ein Array of Strings ein & Lscht alle Files aus der Liste,
    // die kein Rechnungsfile sind. Das Array liefert dann alle "rechnung*.txt"-Files 
    // an aufrufende Methode
    private static String[] getRechnungsFilenames (String pfad)
	{
	// ffnet Directory
	File file = new File (pfad);
	
	// Liet alles Filenamen im angegebenen Directory ein
	String f[] = file.list ();
	int anz = 0;
	
	for (int i = 0; i < f.length; i++)
	    if ((f[i].length() > 12) && (f[i].substring (0, 8).equalsIgnoreCase ("rechnung")) && (f[i].substring (f[i].length() - 4, f[i].length()).equalsIgnoreCase (".txt")))
		f [anz++] = f [i];

	// Erstellt Array mit den gesuchten Dateinamen
	String h[] = new String[anz];
	for (int i = 0; i < anz; i++)
	    h[i] = f[i];

	// Retourniert Referenz auf Liste mit Rechnungsfiles
	return h;
	}
    
    // Wertet die bergabeparameter aus
    private static void getParameters (String argv[])
	{
	int headersize = 16, textsize = 14;

	// Auswertung der bergabeparameter
	switch (argv.length)
	    {
	    // ohne Parameter, Defaultwerte verwenden
	    case 0: break;
	    
	    // Bei 1 Parameter, wird versucht die Schriftgrsse zu setzen
	    case 1:
		try {
		    headersize = textsize = Integer.parseInt (argv [0]);
		    }
		catch (NumberFormatException e)
		    {
		    // Bei Fehler: Fehlermeldung und Standardwerte setzen
		    ausg.add ("Falsches Argument: " + e.getMessage (), false);
		    ausg.add ("Es werden die Defaultwerte verwendet", false);
		    headersize = 16;
		    textsize = 14;
		    }
		break;
	    
	    // Bei 2 Parametern, berschriftsgrsse und Textgrsse setzen
	    case 2:
		// setzen der berschriftsgrsse
		try {
		    headersize = Integer.parseInt (argv [0]);
		    }
		catch (NumberFormatException e)
		    // Bei Fehler: Fehlermeldung und Standardwerte setzen
		    {
		    ausg.add ("Falsches Argument: " + e.getMessage (), false);
		    ausg.add ("Es werden die Defaultwerte verwendet", false);
		    headersize = 16;
		    }

		// setzen der Textschriftgrsse
		try {
		    textsize = Integer.parseInt (argv [1]);
		    }
		catch (NumberFormatException e)
		    // Bei Fehler: Fehlermeldung und Standardwerte setzen
		    {
		    ausg.add ("Falsches Argument: " + e.getMessage (), false);
		    ausg.add ("Es werden die Defaultwerte verwendet", false);
		    textsize = 14;
		    }
		break;
	    default: 
		ausg.add ("Falsche Argumentenanzahl. Es werden die Defaultwerte verwendet", false);
		break;
	    }
		
	// definieren der Schriftarten mit der ausgewerteten Schriftgrsse
	textfont = new Font ("Monospaced", Font.PLAIN, textsize);
	headerfont = new Font ("Monospaced", Font.BOLD, headersize);
	}
    }