import java.util.*;

// Verwaltet die Rechenstze
public class Rechnung
    {
    private Rechnungen [] r = new Rechnungen [10];
    private int anz;

    // Konstruktor
    Rechnung ()
	{
	anz = 0;
	}

    // Hier werden die Rechenstze abgelegt
    private class Rechnungen
	{
	int artikel;
	int menge;
	Rechnungen (int a, int m)
	    {
	    artikel = a;
	    menge = m;
	    }
	}

    // liet die Rechnungen aus angegebenem File ein
    void load (String path, String filename, MagList l) throws MyException
	{
	String s = null;
	int stck = 0, trennzeichen = 0, artikel = 0, artnr = 0;
	ReadFile file;
		
	try {	
	    // ffnet File
	    file = new ReadFile (path, filename);
	    }
	catch (MyException e)
	    {
	    throw new MyException (e.getMessage ());
	    }

	// Liet bis zum Fileende ein, oder bricht bei mehr als 10 Rechnungsstzen ab
	while ((s = file.readLine()) != null)
	    {
	    // Abbruch, wenn mehr als 10 Rechenstzen
            if (anz > 10)
	        throw new MyException ("Zu viele Artikel in dieser Rechnung.\nEs wurden nur die ersten 10 bercksichtigt.");
	    try 
		{	
		// Wandelt Sting in Rechnungsdatensatz um
		StringtoRechnung (s);
		}
	    catch (MyException e)
		{
		l.add (e.getMessage (), false);
		}
    	    }
	}


    // Versucht den bergebenen String im Array "Rechnungen" abzulegen	
    private void StringtoRechnung (String s) throws MyException
	{
	int artikel = 0, stck = 0, artnr = 0;
	String help = null;
	
	// Initialisiert Stringteiler und definiert die Trennzeichen
	StringTokenizer T = new StringTokenizer (s, ",");

	try {
	    if ((T.countTokens () != 2) || (s.charAt (s.length () - 1) == ','))
		throw new MyException ("Falsche Syntax: " + s + " - Datensatz ignoriert.");
	    artikel = Integer.parseInt (T.nextToken());
	    stck = Integer.parseInt (T.nextToken());
	    } 
	catch (NumberFormatException e)
	    {
	    throw new MyException ("Fehler im Datensatz: " + s + " - Datensatz ignoriert.");
	    }
	    
	// berprft, ob dieser Artikel in der Rechnung schon vorkommt
	//  ja: ergnzt den alten Rechnungssatz
	//  nein: legt neuen Rechnungssatz an
	if ((artnr = find (artikel)) >= 0)
	    r [artnr].menge += stck;
	else
	    r [anz++] = new Rechnungen (artikel, stck);
	}


    // Sucht in Rechnungsstzen nach angegebener Artikelnummer
    int find (int art)
	{
	for (int i = 0; i < anz; i++)
	    if (art == r[i].artikel)
		return (i);
	return -1;
	}
    
    // Liefert die Anzahl der geladenen Rechnungen zurck
    int anz ()
	{
	return anz;
	}
    
    // Setzt die Eintrge auf 0 zurck
    void destroy ()
	{
	anz = 0;
	}

		
    // Liefert die gesuchte Artikelnummer
    int nummer (int j)
	{
	return r[j].artikel;
	}
	

    // Liefert die gesuchte Artikelmenge
    int menge (int j)
	{
	return r[j].menge;
	}
    }
