/**
 * Bannerprogramm: Liet Strings aus einem File ein und gibt diese in der vorher geladenen Schrift aus
 *
 * Die Strings sind im File "banner.txt" enthalten das nach folgenden Schema aufgebaut ist:
 *    Datensatz: "10 Das ist der Text" (Die Zahl vor dem Text stellt den Vergrerungsfaktor dar)
 *
 * Die Schriftart setzt sich aus mehreren "*.def"-Files zusammen, wo bei "A.def" fr den Buchstaben A steht, usw.
 * Ein "*.def" File kann nun folgende Inhalte haben, aus denen sich ein Buchstabe zusammensetzt:
 *    1.) "Strich <x1> <y1> <x2> <y2>"
 *    2.) "Kurve <x> <y> <Auenradius> <Anfangswinkel> <Bogenwinkel>"
 */

import java.awt.*;
import java.awt.event.*;

public class Banner extends Frame
    {
    private static MyChars c;
    private static Banners b;
    final static int STARTWIDTH = 400, STARTHEIGHT = 300;
    final static String PFAD1 = "/mnt/import/java/tests/letters/", FILE = "banner.txt", PFAD2 =  "./";

    /**
     * Constructor.
     * Hier wird der Zeichen Canvas initialisiert.
     */
    public Banner () 
	{
	addWindowListener (new Fensterschliesser());
	
	setLayout (new BorderLayout());
	  OutputCanvas output = new OutputCanvas ();
	  ScrollPane scrollpane = new ScrollPane ();
	  scrollpane.add (output);
	  add (scrollpane);
	  scrollpane.doLayout ();

	  // Setzt Scrollbareinheiten
	  scrollpane.getHAdjustable().setUnitIncrement (40);
	  scrollpane.getVAdjustable().setUnitIncrement (30);	
	}
    
    /**
     * Klasse: OutputCanvas.
     * Die Zeichenflche. Die Abmessungen des Canvas werden durch die auszugebenden Strings definiert.
     * Der Canvas ist aber mindestens so gro, wie der geffnete Frame.
     */
    private class OutputCanvas extends Canvas
	{
	/**
	 * Konstruktor.
	 * Hier wird die gre des Canvas berechnet & gesetzt
	 */
	OutputCanvas ()
	    {
	    int w = b.getMaxWidth () + 30, h = b.getMaxHeight () + 30;
	    if (w < STARTWIDTH)
		w = STARTWIDTH;
	    if (h < STARTHEIGHT)
		h = STARTHEIGHT;
	    setSize (w, h);
	    }
	
	/**
	 * Methode: paint
	 * Hier werden die einzelnen Zeilen des auszugebenden Textes gelesen und an die Methode drawMyString (..)
	 * aus der Classe MyChars bergeben.
	 **/
	public void paint (Graphics g)
	    {
	    int i = 30;
	    for (b.reset (); !b.eol (); b.nextElement ())
		{
		i += 2 * b.getSize ();
		c.drawMyString (g, b.getString (), b.getSize (), 30, i);
		i += 9 * b.getSize ();
		}
	    }
	}

    /**
     * Klasse: Fensterschlisser
     * Implementiert das windowClosing Event zum Schlieen des Frames
     */
    class Fensterschliesser extends WindowAdapter
	{
	public void windowClosing (WindowEvent e)
	    {System.exit (0);}
	}
    
    /**
     * Das Hauptprogramm.
     * Hier werden die bentigten Daten geladen, und das Frame initialisiert
     */
    public static void main(String args[]) 
	{
	// Einlesen der *.def Files mit den Anweisungen zum Zeichnen der Zeichen
	c = new MyChars (PFAD1);
	
	// Einlesen des Files mit den auszugebenden Texten
	b = new Banners (PFAD2, FILE);
    
	Frame f = new Banner ();
	f.setTitle ("Banner");
	f.setSize (STARTWIDTH, STARTHEIGHT);
	f.setVisible (true);

	// bergibt die Zeichnungsfarben an die Klasse Chars
	c.setForeBackColor (f.getForeground (), f.getBackground ());
	}
    }
