/**
 * Klasse: Banners.
 * Hier werden die Bans gesichert und verwaltet.
 */
public class Banners
    {
    private MagList data;
    
    /**
     * Klasse: Bans.
     * In diesem Format werden die einzelen Bannertexte und deren Vergrerungsfaktor abgelegt.
     */
    private class Bans
	{
	int size;
	String data;
	
	Bans (int s, String d)
	    {
	    size = s;
	    data = d;
	    }
	}
   
    /**
     * Constructor.
     * Liet die auszugebenden Zeilen aus dem angegebenen File ein und legt sie in einer Liste ab.
     */
    Banners (String pfad, String filename)
	{
	data = new MagList ();
	String s = null;
	ReadFile file;
	int size = 0, t;
	boolean fund = false;

	// versucht das gewnschte File im angegebenen Pfad zu ffenen
	file = new ReadFile (pfad, filename);
    
	// Solange Daten vorhanden Zeilen einlesen und auswerten
	while (((s = file.readLine()) != null) && (s.length() > 0))
	    {
	    fund = true;
	    if ((t = s.indexOf (' ')) > 0)
		{
		try {size = Integer.parseInt (s.substring (0, t));}
		catch (NumberFormatException e) {}
		s = s.substring (t+1);
		if ((size > 0) && (s.length() > 0))
		    data.add (new Bans (size, s));
		else System.out.println ("Ungltige Zeile gefunden: " + s);
		}
	    else System.out.println ("Fehler beim Lesen der Zeile: " + s);
	    }

	// Schliet das File wieder, falls  eines geffnet wurde
	if (fund) file.close ();
	}
    
    /**
     * Methode: reset.
     * Setzt die Liste data auf ersten Eintrag zurck.
     */
    public void reset ()
	{
	data.reset ();
	}

    /**
     * Methode: getString.
     * Gibt den String (Bannerzeile), des aktuellen Bans zurck.
     * @return Den aktuellen String.
     */	
    public String getString ()
	{
	return ((Bans)data.getData()).data;
	}

    /**
     * Methode: getSize.
     * Gibt den Vergrerungsfaktor, des aktuellen Bans zurck.
     * @return Den aktuellen Vergrerungsfaktor.
     */
    public int getSize ()
	{
	return ((Bans)data.getData()).size;
	}

    /**
     * Methode: nextElement.
     * Geht in der Liste auf das nchste Element, wenn das aktuelle noch nicht das Letzte ist und liefert true zurck.
     * Wenn das aktuelle Element das letzte ist, liefert die Methode false.
     * @return Gibt true zurck, wenn ein nchstes Element existiert hat.
     */
    public boolean nextElement ()
	{
	if (!data.eol())
	    {
	    data.gotoNext ();
	    return true;
	    }
	else return false;
	}
	
    public boolean eol ()
	{
	return data.eol ();
	}
	
    /**
     * Methode: getMaxWidth.
     * liefert die Lnge (in Pixel) des grten auszugebenden Strings in Abhngigkeit vom Vergrsserungfaktor.
     **/
    public int getMaxWidth ()
	{
	int w = 0;
	for (reset (); !eol (); nextElement ())
	    if ((getString().length() * getSize() * 6) > w)
		w = getString().length () * getSize() * 6;
	return w;
	}

    /**
     * Methode: getMaxHeight.
     * liefert maximale Hhe aller Strings.
     **/
    public int getMaxHeight ()
	{
	int h = 0;
	for (reset (); !eol (); nextElement ())
	    h += getSize() * 11;
	return h;
	}
    }