/**
 * Klasse: MagList.
 * Speichert und Verwaltet dynamische Datenstrukturen in einer doppelt verketteten Liste.
 */
public class MagList
    {
    // Hilfsnodes, zur Verwaltung und Ansteuerung der Liste
    private Node start, now, end;

    /**
     * Konstruktor.
     * Hier werden die Hilfsnodes zum Verwalten der Daten initialisiert.
     */    
    public MagList ()
	{
	now = null;
	start = null;
	end = null;
	}
    
    /**
     * Methode: add.
     * Fgt ein neues Element in die Liste mit der gre des bergebenen Objektes ein.
     */
    public void add (Object x)
	{
	// Wenn kein Element initialisiert ist: neues Element erzeugen und Hilfsnodes setzen
	if (start == null)
	    {
	    start = new Node (x, null, null);
	    end = now = start;
	    }
	// Wenn schon mind. ein Element initialisiert ist: neues Element erzeugen
	else
	    {
	    Node T = new Node (x, now.next, now);
	    now.next = T;
	    now = T;
	    if (now.next == null)
		end = T;
	    }
	}
    
    /**
     * Methode: eol.
     * berprft, ob das Ende der Liste erreicht wurde.
     * @return true, wenn das Ende der Liste erreicht, sonst false.
     */
    public boolean eol ()
	{
	return now == null;
	}
    
    /**
     * Methode: gotoNext.
     * Setzt den Hilfspointer now auf das nchste Element in der Liste.
     */
    public void gotoNext ()
	{
	now = now.next;
	}
    
    /**
     * Methode: gotoLast.
     * Setzt den Hilfspointer now auf das vorherige Element in der Liste.
     */
    public void gotoLast ()
	{
	now = now.last;
	}
    
    /**
     * Methode: reset.
     * Setzt den Hilfspointer now zurck auf den Start der Liste.
     */
    public void reset ()
	{
	now = start;
	}
    
    /**
     * Methode: getData.
     * @return Liefert das gespeicherte Objekt, der aktuellen Listenposition zurck.
     */
    public Object getData ()
	{
	return now.data;
	}
	
    /**
     * Methode: destroy.
     * Setzt alle Hilfnodes auf null zurck -> Lschen der Liste.
     */
    public void destroy ()
	{
	start = null;
	now = null;
	end = null;
	}
    
    /**
     * Klasse: Node.
     * In diesem Format werden die einzelnen Elemente der Liste abgelegt.
     */
    private class Node 
	{
	Object data;
	Node next;
	Node last;
	
	Node (Object d, Node n, Node l)
	    {
	    data = d;
	    next = n;
	    last = l;
	    }
	}
    }